<?php
// pdfdir.php
//

require_once 'pdfportal.php';

$src_dir= $_GET['dir'];
$src_dir= rtrim( $src_dir, '/' ).'/';
$src_dir= '/'.ltrim( $src_dir, '/' );
$src_dir_full= $_SERVER['DOCUMENT_ROOT'].$src_dir;
$src_dir_url= 'http://'.$_SERVER['HTTP_HOST'].$src_dir;

// base URL of this script
$self_dir_url= 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];

// base URL of pdffile.php
$pdffile_dir_url= dirname($self_dir_url).'/pdffile.php';

function 
load_directory_data( $src_dir_full,
		     &$dir_fn_ar,
		     &$pdf_fn_ar )
{
  if( is_dir($src_dir_full) ) {
    if( $dir_h= opendir($src_dir_full) ) {
      while( ($dir_fn= readdir($dir_h)) !== FALSE ) {
	if( is_dir($src_dir_full.$dir_fn) && $dir_fn!= '.' && $dir_fn!= '..' ) {
	  $dir_fn_ar[]= $dir_fn;
	}
	else if( strtolower(substr($src_dir_full.$dir_fn,-4))== '.pdf' ) {
	  $pdf_fn_ar[]= $dir_fn;
	}
      }
    }
  }
}

function
output_dir_parent_line( $src_dir,
			$self_dir_url,
			&$num_parents )
{
  $src_dir= rtrim($src_dir, '/');
  $slash_pos= strrpos($src_dir, '/' );
  $top_level_b= TRUE;
  $num_parents_begin= $num_parents;
  ++$num_parents;

  if( $slash_pos!== FALSE && $slash_pos!= 0 ) {
    output_dir_parent_line( substr($src_dir, 0, $slash_pos+ 1),
			    $self_dir_url,
			    $num_parents );
    $top_level_b= FALSE;
  }

  if( !$top_level_b ) {
    echo ' / ';
  }
  if( $num_parents_begin== 0 ) { // we were the first called
    // don't create a hyperlink
    echo "<span class=\"dtl\">".substr( $src_dir, $slash_pos+ 1 )."</span>\n";
  }
  else {
    echo "<span class=\"dpl\"><a href=\"$self_dir_url?dir=$src_dir/\">" .
      substr( $src_dir, $slash_pos+ 1 )."</a></span>\n";
  }
}

function
output_dir_parent_tree( $src_dir,
			$self_dir_url,
			&$num_parents,
			$leave_open_b )
{
  $src_dir= rtrim($src_dir, '/');
  $slash_pos= strrpos($src_dir, '/' );
  $top_level_b= TRUE;
  $num_parents_begin= $num_parents;
  ++$num_parents;

  if( $slash_pos!== FALSE && $slash_pos!= 0 ) {
    output_dir_parent_tree( substr($src_dir, 0, $slash_pos+ 1),
			    $self_dir_url,
			    $num_parents,
			    $leave_open_b );
    $top_level_b= FALSE;
  }

  echo '<ul><li>';
  if( $num_parents_begin== 0 ) { // we were the first called
    // don't create a hyperlink
    echo "<div class=\"dtt\">".substr( $src_dir, $slash_pos+ 1 )."</div>\n";

    if( !$leave_open_b ) { // clean up
      for( $ii= 0; $ii< $num_parents; ++$ii ) {
	echo '</li></ul>';
      }
    }
  }
  else {
    echo "<div class=\"dpt\"><a href=\"$self_dir_url?dir=$src_dir/\">" .
      substr( $src_dir, $slash_pos+ 1 )."</a></div>\n";
  }
}

$pdf_fn_ar= array();
$dir_fn_ar= array();
load_directory_data( $src_dir_full,
		     $dir_fn_ar,
		     $pdf_fn_ar );
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>PDF Portal: <?php echo $src_dir_url ?></title>
<style type="text/css">
<!--
div.dpt, div.dfn { font-family: sans-serif; margin-top: 2px; margin-bottom: 2px }
div.dtt { font-family: sans-serif; font-size: 110%; font-weight: bold; margin-top: 2px; margin-bottom: 2px }

span.hit_title { font-family: serif }
span.hit_link { font-family: sans-serif; font-size: 80% }
span.hit_size { font-family: sans-serif; font-size: 90% }
span.hit_date { font-family: sans-serif; font-size: 90% }
span.hit_authors { font-family: sans-serif; font-size: 90% }

span.th { font-family: sans-serif; font-weight: bold; color: white; font-size: 80% }
-->
</style>
</head>
<body>
<center><table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
<td align="center" valign="top" width="15%" bgcolor="white">&nbsp;<br>
<?php // an icon
if( $pdfportal_icon_url ) {
  echo '<img src="'.$pdfportal_icon_url.'" alt="Icon">';
}
?>
<br>&nbsp;
</td>
<td>
<?php // output a tree of directory parents and children
$num_parents= 0;
output_dir_parent_tree( $src_dir,
			$self_dir_url,
			$num_parents,
			true );

if( count($dir_fn_ar) ) {
  echo '<ul>';
  foreach( $dir_fn_ar as $dir_fn ) {
    echo "<li><div class=\"dfn\"><a href=\"$self_dir_url?dir=$src_dir$dir_fn/\">" .
      $dir_fn."</a></div></li>";
  }
  echo '</ul>';
}
for( $ii= 0; $ii< $num_parents; ++$ii ) {
  echo '</li></ul>';
}
?>
</td>
</tr></table>
<hr>
<?php // output a table of PDF files in this directory
if( count($pdf_fn_ar) ) {
  echo '<table border=0 width="100%" cellspacing=2 cellpadding=2>';
  echo '<tr bgcolor="#3333cc">
<td align="center"><span class="th">Title</span></td>
<td><span class="th"></span></td>
<td align="center"><span class="th">Size (kB)</span></td>
<td align="center"><span class="th">Pages</span></td>
<td align="center"><span class="th">Last Updated</span></td>
<td align="center"><span class="th">Date Created</span></td>
<td><span class="th">Authors</span></td>
</tr>';

  $color_row_b= FALSE; // alternate colors
  foreach( $pdf_fn_ar as $pdf_fn ) {
    $pdf_data_ar= array();
    $pdf_info_ar= array();
    $pdf_bookmark_ar= array();

    load_pdf_info( $src_dir_full.$pdf_fn,
		   $pdf_data_ar,
		   $pdf_info_ar,
		   $pdf_bookmark_ar,
		   TRUE ); // fill info only

    // document title
    if( !array_key_exists('Title', $pdf_info_ar) ||
	!$pdf_info_ar['Title'] )
      {
	$pdf_info_ar['Title']= basename($pdf_fn);
      }

    if( $color_row_b ) {
      echo '<tr bgcolor="#eeeeee">';
    }
    else {
      echo '<tr>';
    }
    echo 
'<td><span class="hit_title"><a href="'.$pdffile_dir_url.'?pdf='.$src_dir.$pdf_fn.'">'.$pdf_info_ar['Title'].'</a></span></td>
<td align="center"><span class="hit_link"><a style="color: green" href="'.$src_dir_url.$pdf_fn.'">Direct</a></span></td>
<td align="right"><span class="hit_size">'.(int)(filesize($src_dir_full.$pdf_fn)/1024).'</span></td>
<td align="right"><span class="hit_size">';
if( array_key_exists('NumberOfPages',$pdf_data_ar) ) {
  echo $pdf_data_ar['NumberOfPages'];
}
echo
'</span></td>
<td align="right"><span class="hit_date">';
if( array_key_exists('ModDate',$pdf_info_ar) ) {
  echo readable_pdf_date($pdf_info_ar['ModDate']);
}
echo
'</span></td>
<td align="right"><span class="hit_date">';
if( array_key_exists('CreationDate',$pdf_info_ar) ) {
  echo readable_pdf_date($pdf_info_ar['CreationDate']);
}
echo '</span></td>
<td><span class="hit_authors">';
if( array_key_exists('Author',$pdf_info_ar) ) {
  echo $pdf_info_ar['Author'];
}
echo
'</span></td>
</tr>';

    $color_row_b= !$color_row_b;
  }

  // repeat headings
  echo '<tr bgcolor="#3333cc">
<td align="center"><span class="th">Title</span></td>
<td><span class="th"></span></td>
<td align="center"><span class="th">Size (kB)</span></td>
<td align="center"><span class="th">Pages</span></td>
<td align="center"><span class="th">Last Updated</span></td>
<td align="center"><span class="th">Date Created</span></td>
<td><span class="th">Authors</span></td>
</tr>
</table>';
}
?>
<hr>
<center><div style="font-family: sans-serif; font-size: 80%">Powered by <a href="http://www.pdfhacks.com">PDF Hacks</a></div></center>
</center>
</body></html>
